/* Precognition Multiple Window Code Writer - Lee Willis */

/* =====================================================
**   Created by the Precognition Interface Builder
** =====================================================
**
**  Link this file with 'Precognition.lib'
**
*/

#include <stdio.h>
#include <stdlib.h> /* prototype for exit() */
#include "Precognition.h"
#include "MultiWindowWriter/pmwcw_writer.h"
#include "FileRequester/pcg_FileReq.h"
#include "Intuition_Utils.h"
#include "BuilderMethods/patchClasses.h"
#ifndef __GNUC__
#include <clib/exec_protos.h>
#include <clib/alib_protos.h>
#include <clib/intuition_protos.h>
#include <clib/graphics_protos.h>
#endif
#ifdef __GNUC__
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#endif
#ifdef __SASC
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#endif

/* EDB -- added version string */
char *MultiWindowWriter_version = "$VER: MultiWindowWriter 2.1 (9.1.95)";
   /*
   ** This string needs to be in there somewhere for the
   ** AmigaDOS VERSION command to find it.
   */

struct FileReqInfo filereq_info;
char filename[130];


/*
** The event loop is terminated when 'Done' is true.
*/

BOOL Done = FALSE;


struct my_window0
{
   pcgWindow      w;
   OutlineBox     outlinebox7;
   ListEditor     listeditor3;
   BoolGadget     boolgadget4;
   BoolGadget     boolgadget5;
   CycleGadget    cyclegadget8;
};

struct MsgPort *shared_port;

/*=============== Prototypes ====================*/

#ifdef ANSI_HEADERS

   void  my_window0_Init(
              struct my_window0 *window,
              struct Screen *screen,
              struct MsgPort *userport );

   void  my_window0_CleanUp( struct my_window0 *window );

   ULONG my_window0_Respond(
              struct my_window0 *window,
              struct IntuiMessage *event );

   void  my_window0_EventLoop( struct Screen *screen, struct MsgPort *userport );

   void  GracefulExit( int ExitStatus );

#else

   void  my_window0_Init();
   void  my_window0_CleanUp();
   ULONG my_window0_Respond();
   void  my_window0_EventLoop();
   void  GracefulExit();

#endif

char *cyclegadget8_choices[] =
{
   "Window is initially OPEN",
   "Window is initially CLOSED",
   NULL
};

int
selectedIndex( StringList *slist )
{
   int i;
   for( i = 0; i < slist->nEntries; i++ )
   {
      if( slist->Qualifiers[i] & ENTRY_SELECTED )
         return i;
   }
   return -1;
}


void my_window0_Init( window, screen, userport )
   struct my_window0 *window;
   struct Screen *screen;
   struct MsgPort *userport;
{
   pcg_3DPens    pens;

/*   pens = StandardPens();   */
   pens = StandardScreenPens( screen );

   /* Initialize the window */
   pcgWindow_Init( &window->w,
      0, 12, 450, 190, /* LeftEdge, TopEdge, Width, Height */
      100, 50, 65535, 65535, /* min width & height, max width & height */
      "Precognition Multi-Window Code Writer", /* title */
      REFRESHWINDOW | CLOSEWINDOW, /* IDCMPFlags */
      WINDOWDRAG | WINDOWDEPTH | WINDOWCLOSE | SIMPLE_REFRESH | ACTIVATE, /* Flags */
      screen );

   window->w.SharedUserPort = userport;

   OutlineBox_Init( &window->outlinebox7,
      10, 20, 430, 140, /* LeftEdge, TopEdge, Width, Height */
      pens, " Precognition Window Files " );
   AddWindowPObject( &window->w, (GraphicObject *)&window->outlinebox7 );

   ListEditor_Init( &window->listeditor3,
      19, 28, 420, 110, /* LeftEdge, TopEdge, Width, Height */
      pens, NULL );
   AddWindowPObject( &window->w, (GraphicObject *)&window->listeditor3 );

   BoolGadget_Init( &window->boolgadget4,
      112, 120, 152, 14, /* LeftEdge, TopEdge, Width, Height */
      pens, "File Requester..." );
   AddWindowPObject( &window->w, (GraphicObject *)&window->boolgadget4 );

   CycleGadget_Init( &window->cyclegadget8,
      19, 138, 245, pens, NULL, cyclegadget8_choices );
   EnableIactor( (Interactor *)&window->cyclegadget8, FALSE );
   AddWindowPObject( &window->w, (GraphicObject *)&window->cyclegadget8 );

   BoolGadget_Init( &window->boolgadget5,
      112, 168, 152, 16, /* LeftEdge, TopEdge, Width, Height */
      pens, "Write the Code..." );
   AddWindowPObject( &window->w, (GraphicObject *)&window->boolgadget5 );

}


void my_window0_CleanUp( window )
   struct my_window0 *window;
{
   CleanUp( (PObject *)&window->w );
   CleanUp( (PObject *)&window->outlinebox7 );
   CleanUp( (PObject *)&window->listeditor3 );
   CleanUp( (PObject *)&window->boolgadget4 );
   CleanUp( (PObject *)&window->boolgadget5 );
   CleanUp( (PObject *)&window->cyclegadget8 );
}


ULONG my_window0_Respond( window, event )
     struct my_window0 *window;
     struct IntuiMessage *event;
{
   ULONG response, r;
   int i, qual;
   struct Window *intuition_window;
   struct StringList *slist;

   response = 0L;

   /* check to see if 'event' happenned in this window */
   intuition_window = iWindow( &window->w );
   if( event->IDCMPWindow == intuition_window )
   {
      switch( event->Class )
      {

         case CLOSEWINDOW:
            pcgCloseWindow( &window->w );

            Done =  TRUE; /* Trigger exit of the event loop */
            break;

         case REFRESHWINDOW:
            BeginRefresh( intuition_window );
            Refresh( (Interactor *)&window->w );
            EndRefresh( intuition_window, TRUE );
            break;

         default:
            r = Respond( (Interactor *)&window->listeditor3, event );
            if( r & CHANGED_STATE )
            { /* An item was selected/added/deleted. */
               slist = StringList_of( (StringLister *)&window->listeditor3 );
               if( ( i = selectedIndex( slist ) ) != -1 )
               {
                  qual = slist->Qualifiers[i];
                  SetValue( (Valuator *)&window->cyclegadget8, ( i == ENTRY_SPECIAL ? 1:0 ) );
                  EnableIactor( (struct Interactor *)&window->cyclegadget8, TRUE );
                  Refresh( (struct Interactor *)&window->cyclegadget8 );
               }
/*
               else if( window->listeditor3.state == 2 )
               {
                  SetValue( &window->cyclegadget8, 0 );
                  EnableIactor( &window->cyclegadget8, TRUE );
                  Refresh( &window->cyclegadget8 );
               }
*/
               else
               {
                  EnableIactor( (struct Interactor *)&window->cyclegadget8, FALSE );
               }
              response |= r;
            }

            r = Respond( (Interactor *)&window->boolgadget4, event );
            if( r & CHANGED_STATE )
            {  /* boolgadget4 was hit. */
               response |= r;
               filereq_info.MustExist = TRUE;
               filereq_info.title = "Select the Precognition Window file to add...";
               if( pcg_FileReq( &filereq_info ) )
               {
                  AddString( (StringLister *)&window->listeditor3, &filename[0], 0 );
               }
            }

            r = Respond( (Interactor *)&window->cyclegadget8, event );
            if( r & CHANGED_STATE )
            {  /* cyclegadget8 was hit. */
               slist = StringList_of( (StringLister *)&window->listeditor3 );
               if( ( i = selectedIndex( slist ) ) != -1 )
               {
                  if( Value( (Valuator *)&window->cyclegadget8 ) )
                  {
                     slist->Qualifiers[i] |= ENTRY_SPECIAL;
                  }
                  else
                  {
                     slist->Qualifiers[i] &= ( ~ENTRY_SPECIAL );
                  }
                  Refresh( (struct Interactor *)&window->listeditor3 );
               }
               else
               {
                  EnableIactor( (struct Interactor *)&window->cyclegadget8, FALSE );
               }

               response |= r;
            }

            r = Respond( (Interactor *)&window->boolgadget5, event );
            if( r & CHANGED_STATE )
            {  /* boolgadget5 was hit. */
               response |= r;
               EnableIactor( (Interactor*) &window->w, FALSE );
               pmwcw_WriteCode("", StringList_of( (StringLister *)&window->listeditor3 ));
               EnableIactor( (Interactor*) &window->w, TRUE );
               Done = TRUE; /* YOUR CODE HERE */
            }

            break;

      } /* end switch */

   } /* end if */

   return response;
}


void my_window0_EventLoop ( screen, userport )
   struct Screen *screen;
   struct MsgPort *userport;
{
   struct my_window0 my_window0;
   struct Window *iw;              /* Intuition window */
   struct IntuiMessage *imsg, event;

   my_window0_Init( &my_window0, screen, userport );

   if( ( iw = pcgOpenWindow( &my_window0.w ) ) != NULL )
   {
      /*====== Event Loop ================*/
      while( ! Done )
      {
         imsg = WaitForMessage( userport );
         event = *imsg;
         ReplyMsg( (struct Message *)imsg );

         my_window0_Respond( &my_window0, &event );

      }

      pcgCloseWindow( &my_window0.w );
   }
   else /* Error : window couldn't be openned. */
   {
      ; /*** YOUR ERROR HANDLING HERE ***/
   }


   my_window0_CleanUp( &my_window0 );
}


#include <stdio.h>
#include <intuition/screens.h>

/* declare lib structures */
struct IntuitionBase *IntuitionBase = NULL;
struct GfxBase       *GfxBase       = NULL;

#define HAS_CONSOLE ( argc > 0 )
/*
** If 'argc' is greater than 0, than the program was started from
** the command line, and therefore has a console that one can
** 'fprintf' to.
**
** If 'argc' == 0, this was started from Workbench.  It's not
** safe to assume there's a console attached to programs started
** from Workbench.
*/

struct Screen *screen;

int main ( argc, argv )
   int argc;
   char **argv;
{


   /* open intuition library */
   IntuitionBase = (struct IntuitionBase *)
      OpenLibrary("intuition.library", 0 );
   if( IntuitionBase == NULL )
   {
      if( HAS_CONSOLE )
         fprintf( stderr, "Error: couldn't open intuition.library\n");
      GracefulExit( 10 );
   }

   GfxBase = (struct GfxBase *)
      OpenLibrary("graphics.library", 0 );
   if( GfxBase == NULL )
   {
      if( HAS_CONSOLE )
         fprintf( stderr, "Error: couldn't open graphics.library\n");
      GracefulExit( 20 );
   }

   /*
    * Install Builder methods into the Precognition classes
    */
   patchClasses();

   if( ( shared_port = CreatePort( NULL, 0 ) ) == NULL )
   {
      printf( "couldn't create a Message port.\n" );
      GracefulExit( FALSE );
   }

   /* Open a screen, if desired. */

   filereq_info.screen           = screen;
   filereq_info.SharedUserPort   = shared_port;
   filereq_info.FullPathName     = &filename[0];

   /* Now do the window event loop. */
   my_window0_EventLoop( screen, shared_port );

   GracefulExit( 0 );
   return 0;
}


void GracefulExit( int status )
{
   if( shared_port )
   {
      DeletePort( shared_port );
      shared_port = NULL;
   }

   if( GfxBase )
   {
      CloseLibrary( (struct Library *)GfxBase );
      GfxBase = NULL;
   }

   if( IntuitionBase )
   {
      CloseLibrary( (struct Library *)IntuitionBase );
      IntuitionBase = NULL;
   }

   exit( status );
}

void Builder_Init( void ) {;}


void Builder_CleanUp( void ) {;}

void Builder_Reset( BOOL reopen ) {;}

extern char* proj_filename;

void Builder_EventLoop( void ) {;}

int builderwindow;
int DeferredResponses;
